{
  cluster.modules = [
    ({
      users.users.emv.extraGroups = [
        "podman"
        "docker"
      ];
    })
  ];
  sucrose.modules = [
    ({
      virtualisation.docker = {
        enable = true;
        storageDriver = "btrfs";
        daemon.settings = {
          userland-proxy = false;
          ipv6 = false;
          data-root = "/home/emv/docker-data-root/";
        };
      };
    })
    (
      { pkgs, ... }:
      {
        environment.systemPackages = [ pkgs.podman-compose ];
        virtualisation = {
          containers.enable = true;
          podman = {
            enable = true;
            dockerCompat = false;
            defaultNetwork.settings.dns_enabled = true;
          };
          oci-containers.backend = "podman";
        };
      }
    )
  ];
}
